(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations'), require('@angular/common'), require('rxjs'), require('rxjs/operators'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation', ['exports', '@angular/animations', '@angular/common', 'rxjs', 'rxjs/operators', '@angular/core'], factory) :
    (factory((global.bravobit = global.bravobit || {}, global.bravobit['bb-foundation'] = {}),global.ng.animations,global.ng.common,global.rxjs,global.rxjs.operators,global.ng.core));
}(this, (function (exports,animations,common,rxjs,operators,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var hasV8BreakIterator = (typeof Intl !== 'undefined' && (( /** @type {?} */(Intl))).v8BreakIterator);
    var BbPlatform = /** @class */ (function () {
        function BbPlatform(_platformId) {
            this._platformId = _platformId;
        }
        Object.defineProperty(BbPlatform.prototype, "isBrowser", {
            // Browser check.
            get: 
            // Browser check.
            /**
             * @return {?}
             */
            function () {
                return this._platformId
                    ? common.isPlatformBrowser(this._platformId)
                    : typeof document === 'object' && !!document;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbPlatform.prototype, "isTrident", {
            // Rendering engines.
            get: 
            // Rendering engines.
            /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /(msie|trident)/i.test(navigator.userAgent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbPlatform.prototype, "isBlink", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && (!!((( /** @type {?} */(window))).chrome || hasV8BreakIterator) &&
                    typeof CSS !== 'undefined' && !this.isEdge && !this.isTrident);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbPlatform.prototype, "isWebkit", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /AppleWebKit/i.test(navigator.userAgent)
                    && !this.isBlink && !this.isEdge && !this.isTrident;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbPlatform.prototype, "isChrome", {
            // Browsers.
            get: 
            // Browsers.
            /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /Google Inc./.test(navigator.vendor);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbPlatform.prototype, "isEdge", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /(edge)/i.test(navigator.userAgent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbPlatform.prototype, "isFirefox", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /(firefox|minefield)/i.test(navigator.userAgent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbPlatform.prototype, "isSafari", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /safari/i.test(navigator.userAgent) && this.isWebkit;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbPlatform.prototype, "isIos", {
            // Platforms.
            get: 
            // Platforms.
            /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /iPad|iPhone|iPod/.test(navigator.userAgent) && !('MSStream' in window);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbPlatform.prototype, "isAndroid", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /android/i.test(navigator.userAgent) && !this.isTrident;
            },
            enumerable: true,
            configurable: true
        });
        BbPlatform.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        BbPlatform.ctorParameters = function () {
            return [
                { type: Object, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
            ];
        };
        /** @nocollapse */ BbPlatform.ngInjectableDef = i0.defineInjectable({ factory: function BbPlatform_Factory() { return new BbPlatform(i0.inject(i0.PLATFORM_ID, 8)); }, token: BbPlatform, providedIn: "root" });
        return BbPlatform;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbLanguage = /** @class */ (function () {
        function BbLanguage() {
            this.getLanguages = ( /**
             * @return {?}
             */function () {
                if (typeof navigator !== 'object') {
                    return null;
                }
                /** @type {?} */
                var t = 'anguage';
                /** @type {?} */
                var n = navigator;
                /** @type {?} */
                var f = n['l' + t + 's'];
                /** @type {?} */
                var data = f && f.length ? f : (t = n['l' + t] ||
                    n['browserL' + t] ||
                    n['userL' + t]) ? [t] : t;
                return typeof data === 'string'
                    ? data
                    : data.join(';');
            });
        }
        Object.defineProperty(BbLanguage.prototype, "all", {
            get: /**
             * @return {?}
             */ function () {
                // Get the languages.
                /** @type {?} */
                var data = this.getLanguages();
                // Parse all languages by using a regex.
                /** @type {?} */
                var strings = (data || '')
                    .match(/((([a-zA-Z]+(-[a-zA-Z0-9]+){0,2})|\*)(;q=[0-1](\.[0-9]+)?)?)*/g);
                // Get the content by parsing the strings.
                /** @type {?} */
                var content = strings.map(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) {
                    if (!item) {
                        return null;
                    }
                    /** @type {?} */
                    var bits = item.split(';');
                    /** @type {?} */
                    var ietf = bits[0].split('-');
                    /** @type {?} */
                    var hasScript = ietf.length === 3;
                    return {
                        code: ietf[0],
                        script: hasScript ? ietf[1] : null,
                        region: hasScript ? ietf[2] : ietf[1],
                        quality: bits[1] ? parseFloat(bits[1].split('=')[1]) : 1.0
                    };
                }));
                // Filter out all the empty items
                // and sort them by the quality.
                return content
                    .filter(( /**
             * @param {?} item
             * @return {?}
             */function (item) { return !!item; }))
                    .sort(( /**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */function (a, b) { return b.quality - a.quality; }));
            },
            enumerable: true,
            configurable: true
        });
        BbLanguage.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */ BbLanguage.ngInjectableDef = i0.defineInjectable({ factory: function BbLanguage_Factory() { return new BbLanguage(); }, token: BbLanguage, providedIn: "root" });
        return BbLanguage;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbStorage = /** @class */ (function () {
        function BbStorage() {
            this._store = {};
            // The availability of the local storage.
            this._available = false;
            this.isStorageAvailable = ( /**
             * @return {?}
             */function () {
                if (typeof localStorage !== 'undefined') {
                    try {
                        localStorage.setItem('feature_test', 'yes');
                        if (localStorage.getItem('feature_test') === 'yes') {
                            localStorage.removeItem('feature_test');
                            return true;
                        }
                        else {
                            return false;
                        }
                    }
                    catch (_a) {
                        return false;
                    }
                }
                else {
                    return false;
                }
            });
            // Validate if the localstorage is available.
            this._available = this.isStorageAvailable();
        }
        /**
         * @template T
         * @param {?} token
         * @return {?}
         */
        BbStorage.prototype.get = /**
         * @template T
         * @param {?} token
         * @return {?}
         */
            function (token) {
                if (!this._available) {
                    /** @type {?} */
                    var value = this._store[token];
                    return value === undefined
                        ? null
                        : value;
                }
                // Retrieve the raw data from the local storage.
                /** @type {?} */
                var rawData = localStorage.getItem(token);
                // Try to parse the data.
                /** @type {?} */
                var parsedData = null;
                // Only parse the data when it is not null.
                if (rawData !== null) {
                    try {
                        parsedData = JSON.parse(rawData);
                    }
                    catch (error) {
                        throw new Error('The raw data cannot be parsed; Invalid data in the storage.');
                    }
                }
                // Return the parsed data.
                return parsedData;
            };
        /**
         * @template T
         * @param {?} token
         * @param {?} data
         * @return {?}
         */
        BbStorage.prototype.set = /**
         * @template T
         * @param {?} token
         * @param {?} data
         * @return {?}
         */
            function (token, data) {
                if (!this._available) {
                    this._store[token] = data;
                    return;
                }
                // Stringify the data.
                /** @type {?} */
                var rawData = JSON.stringify(data);
                // Set the raw data in the storage.
                return localStorage.setItem(token, rawData);
            };
        /**
         * @param {?} token
         * @return {?}
         */
        BbStorage.prototype.remove = /**
         * @param {?} token
         * @return {?}
         */
            function (token) {
                if (!this._available) {
                    delete this._store[token];
                    return;
                }
                return localStorage.removeItem(token);
            };
        /**
         * @return {?}
         */
        BbStorage.prototype.clear = /**
         * @return {?}
         */
            function () {
                // If available clear the local storage.
                if (this._available) {
                    return localStorage.clear();
                }
                // Else reset the store object.
                this._store = {};
            };
        BbStorage.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        BbStorage.ctorParameters = function () { return []; };
        /** @nocollapse */ BbStorage.ngInjectableDef = i0.defineInjectable({ factory: function BbStorage_Factory() { return new BbStorage(); }, token: BbStorage, providedIn: "root" });
        return BbStorage;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbImage = /** @class */ (function () {
        function BbImage(_platform) {
            this._platform = _platform;
            // Data.
            this._types = ['image/png', 'image/jpeg'];
            this.calculateOffsetAndDimensions = ( /**
             * @param {?} image
             * @param {?} canvasWidth
             * @param {?} canvasHeight
             * @return {?}
             */function (image, canvasWidth, canvasHeight) {
                /** @type {?} */
                var originalWidth = image.width;
                /** @type {?} */
                var originalHeight = image.height;
                /** @type {?} */
                var widthRatio = canvasWidth / originalWidth;
                /** @type {?} */
                var heightRatio = canvasHeight / originalHeight;
                /** @type {?} */
                var width = 0;
                /** @type {?} */
                var height = 0;
                if (originalWidth > originalHeight) {
                    height = originalHeight * heightRatio;
                    width = (originalWidth / originalHeight) * height;
                }
                else {
                    width = originalWidth * widthRatio;
                    height = (originalHeight / originalWidth) * width;
                }
                /** @type {?} */
                var xOffset = 0;
                /** @type {?} */
                var yOffset = 0;
                if (canvasHeight === height) {
                    xOffset = -((width - canvasWidth) / 2);
                }
                else if (canvasWidth === width) {
                    yOffset = -((height - canvasHeight) / 2);
                }
                return { xOffset: xOffset, yOffset: yOffset, width: width, height: height };
            });
        }
        /**
         * @param {?} contents
         * @param {?=} options
         * @return {?}
         */
        BbImage.prototype.toDataUri = /**
         * @param {?} contents
         * @param {?=} options
         * @return {?}
         */
            function (contents, options) {
                if (options === void 0) {
                    options = null;
                }
                return __awaiter(this, void 0, void 0, function () {
                    var image, canvasWidth, canvasHeight, canvas, context, _a, width, height, xOffset, yOffset;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                // Check if the current platform is a browser.
                                if (!this._platform.isBrowser) {
                                    return [2 /*return*/, null];
                                }
                                // Get the image.
                                return [4 /*yield*/, this.getImage(contents)];
                            case 1:
                                image = _b.sent();
                                // Get the canvas width and height.
                                canvasWidth = (options && options.width) || image.width;
                                canvasHeight = (options && options.height) || image.height;
                                // Get the canvas and context.
                                canvas = document.createElement('canvas');
                                context = canvas.getContext('2d');
                                canvas.width = canvasWidth;
                                canvas.height = canvasHeight;
                                // Check if dimensions where supplied, else create the image.
                                if (!options) {
                                    // Draw the image.
                                    context.drawImage(image, 0, 0);
                                    // Convert the canvas to a data url.
                                    return [2 /*return*/, canvas.toDataURL(this._types[0])];
                                }
                                // Get the dimensions and offsets.
                                _a = this.calculateOffsetAndDimensions(image, canvasWidth, canvasHeight), width = _a.width, height = _a.height, xOffset = _a.xOffset, yOffset = _a.yOffset;
                                // Draw the image.
                                context.drawImage(image, 0, 0, image.width, image.height, xOffset, yOffset, width, height);
                                // Convert the canvas to a data url.
                                return [2 /*return*/, canvas.toDataURL(this._types[0])];
                        }
                    });
                });
            };
        /**
         * @private
         * @param {?} contents
         * @return {?}
         */
        BbImage.prototype.getImage = /**
         * @private
         * @param {?} contents
         * @return {?}
         */
            function (contents) {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        // If the contents is already an HTML image element just return it.
                        if (contents instanceof HTMLImageElement) {
                            return [2 /*return*/, contents];
                        }
                        // If the contents is a file convert it to an HTML image element.
                        if (contents instanceof File) {
                            return [2 /*return*/, this.fileToImage(contents)];
                        }
                        // If the contents is a string convert it to an HTML image element.
                        if (typeof contents === 'string') {
                            return [2 /*return*/, this.stringToImage(contents)];
                        }
                        return [2 /*return*/];
                    });
                });
            };
        /**
         * @private
         * @param {?} file
         * @return {?}
         */
        BbImage.prototype.fileToImage = /**
         * @private
         * @param {?} file
         * @return {?}
         */
            function (file) {
                var _this = this;
                return new Promise(( /**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */function (resolve, reject) {
                    // Check if the file matches an image.
                    if (!_this._types.includes(file.type)) {
                        return reject('The selected file does not meet the required format.');
                    }
                    /** @type {?} */
                    var fileReader = new FileReader();
                    fileReader.readAsDataURL(file);
                    fileReader.onloadend = ( /**
                     * @param {?} data
                     * @return {?}
                     */function (data) {
                        return __awaiter(_this, void 0, void 0, function () {
                            var dataUri, image;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        // Get the data URI.
                                        dataUri = data.target['result'];
                                        // Convert the data URI to a image element.
                                        return [4 /*yield*/, this.stringToImage(dataUri)];
                                    case 1:
                                        image = _a.sent();
                                        // Resolve the image.
                                        return [2 /*return*/, resolve(image)];
                                }
                            });
                        });
                    });
                    fileReader.onerror = ( /**
                     * @param {?} error
                     * @return {?}
                     */function (error) { return reject(error); });
                }));
            };
        /**
         * @private
         * @param {?} src
         * @return {?}
         */
        BbImage.prototype.stringToImage = /**
         * @private
         * @param {?} src
         * @return {?}
         */
            function (src) {
                return new Promise(( /**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */function (resolve, reject) {
                    /** @type {?} */
                    var image = new Image();
                    image.src = src;
                    image.onload = ( /**
                     * @return {?}
                     */function () { return resolve(image); });
                    image.onerror = ( /**
                     * @param {?} error
                     * @return {?}
                     */function (error) { return reject(error); });
                }));
            };
        BbImage.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        BbImage.ctorParameters = function () {
            return [
                { type: BbPlatform }
            ];
        };
        /** @nocollapse */ BbImage.ngInjectableDef = i0.defineInjectable({ factory: function BbImage_Factory() { return new BbImage(i0.inject(BbPlatform)); }, token: BbImage, providedIn: "root" });
        return BbImage;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbInterpolator = /** @class */ (function () {
        function BbInterpolator() {
            // Regex.
            this._checkSubstitution = /{([^}]+)}/g;
            this._replaceSubstitution = /[{}]/g;
            // Collection.
            this._middleware = {};
            this.log = ( /**
             * @param {?} message
             * @return {?}
             */function (message) {
                console && console.warn && console.warn(message);
            });
        }
        /**
         * @param {?} value
         * @param {?} data
         * @return {?}
         */
        BbInterpolator.prototype.interpolate = /**
         * @param {?} value
         * @param {?} data
         * @return {?}
         */
            function (value, data) {
                var _this = this;
                // Match all string inside of curly braces and
                // then filter out all the duplicate items, then
                // we should interpolate all those matches and return
                // the string to the user.
                return (value.match(this._checkSubstitution) || [])
                    .filter(( /**
             * @param {?} item
             * @param {?} index
             * @param {?} array
             * @return {?}
             */function (item, index, array) { return array.indexOf(item) === index; }))
                    .reduce(( /**
             * @param {?} string
             * @param {?} token
             * @return {?}
             */function (string, token) {
                    /** @type {?} */
                    var interpolated = _this.match(token, data);
                    if (interpolated === null) {
                        return string;
                    }
                    return string.replace(new RegExp(token, 'g'), interpolated);
                }), value);
            };
        /**
         * @param {?} token
         * @param {?} middleware
         * @return {?}
         */
        BbInterpolator.prototype.use = /**
         * @param {?} token
         * @param {?} middleware
         * @return {?}
         */
            function (token, middleware) {
                // This add the middleware function to the collection
                // so it can be used at a later time when the user
                // wants to interpolate a value with the middleware.
                this._middleware[token] = middleware;
            };
        /**
         * @private
         * @param {?} match
         * @param {?} dictionary
         * @return {?}
         */
        BbInterpolator.prototype.match = /**
         * @private
         * @param {?} match
         * @param {?} dictionary
         * @return {?}
         */
            function (match, dictionary) {
                var _this = this;
                // Remove the brackets from the match
                // so we get the data between those brackets.
                /** @type {?} */
                var data = match.replace(this._replaceSubstitution, '');
                // Get the token and the methods by splitting
                // on the pipe symbol.
                var _a = __read(data.split('|').map(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) { return item.trim(); }))), token = _a[0], methods = _a.slice(1);
                // Get the value for the token from
                // the dictionary.
                /** @type {?} */
                var value = dictionary[token];
                // Check if the value is undefined, if so
                // we should return null and not proceed.
                if (typeof value === 'undefined') {
                    this.log("Interpolator: value was undefined for token: \"" + token + "\".");
                    return null;
                }
                // Loop through all the middleware methods and try to
                // conform the string to the given parameters.
                return methods.reduce(( /**
                 * @param {?} string
                 * @param {?} middlewareName
                 * @return {?}
                 */function (string, middlewareName) {
                    // Try to retrieve the middleware from the collection.
                    /** @type {?} */
                    var middleware = _this._middleware[middlewareName];
                    // If the middleware is missing return an error
                    // so that the user knows it was not found.
                    if (!middleware) {
                        _this.log("Interpolator: cannot find middleware with name: \"" + middlewareName + "\".");
                        return string;
                    }
                    // Execute the middleware function with the string.
                    return middleware(string);
                }), "" + value);
            };
        BbInterpolator.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */ BbInterpolator.ngInjectableDef = i0.defineInjectable({ factory: function BbInterpolator_Factory() { return new BbInterpolator(); }, token: BbInterpolator, providedIn: "root" });
        return BbInterpolator;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboard = /** @class */ (function () {
        function BbDashboard(_renderer) {
            this._renderer = _renderer;
            // Inputs.
            this.backgroundColor = '#d5dae6';
            this.maxWidth = '1200px';
            this.padding = '20px';
            // State.
            this.sidebarVisible$ = new rxjs.BehaviorSubject(true);
        }
        Object.defineProperty(BbDashboard.prototype, "visibility", {
            get: /**
             * @return {?}
             */ function () {
                return this.sidebarVisible$.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbDashboard.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                // Set the HTML class to prevent scrolling.
                return this.setHtmlClass();
            };
        /**
         * @return {?}
         */
        BbDashboard.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                // Remove the HTML class.
                return this.setHtmlClass(true);
            };
        /**
         * @return {?}
         */
        BbDashboard.prototype.toggleSidebarVisibility = /**
         * @return {?}
         */
            function () {
                // Get the previous value.
                /** @type {?} */
                var previousValue = this.sidebarVisible$.getValue();
                // Invert the value and set the visibility.
                this.setSidebarVisibility(!previousValue);
            };
        /**
         * @param {?} newValue
         * @return {?}
         */
        BbDashboard.prototype.setSidebarVisibility = /**
         * @param {?} newValue
         * @return {?}
         */
            function (newValue) {
                this.sidebarVisible$.next(newValue);
            };
        /**
         * @private
         * @param {?=} shouldRemove
         * @return {?}
         */
        BbDashboard.prototype.setHtmlClass = /**
         * @private
         * @param {?=} shouldRemove
         * @return {?}
         */
            function (shouldRemove) {
                if (shouldRemove === void 0) {
                    shouldRemove = false;
                }
                // Check if the document element is available.
                if (!document || !document.documentElement) {
                    return;
                }
                // Define the class name.
                /** @type {?} */
                var className = 'bb-dashboard-html';
                // Add or remove the class.
                return shouldRemove
                    ? this._renderer.removeClass(document.documentElement, className)
                    : this._renderer.addClass(document.documentElement, className);
            };
        BbDashboard.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-dashboard',
                        template: "<!--\n    The outlet for where the sidebar\n    will be placed (if provided).\n-->\n<ng-content select=\"bb-dashboard-sidebar\">\n</ng-content>\n\n<!--\n    The section containing the header\n    and the main content.\n-->\n<section class=\"bb-dashboard-section\">\n    <!--\n        The outlet for where the header\n        will be placed (if provided).\n    -->\n    <ng-content select=\"bb-dashboard-header\">\n    </ng-content>\n\n    <!--\n        The outlet of the content that\n        will be provided by the router.\n    -->\n    <main [style.background-color]=\"backgroundColor\"\n          [style.padding]=\"padding\"\n          class=\"bb-dashboard-scroll\">\n        <div [style.max-width]=\"maxWidth\"\n             class=\"bb-dashboard-container\">\n            <ng-content></ng-content>\n        </div>\n    </main>\n</section>\n\n<!--\n    The backdrop that will be visible when\n    the sidebar is opened (only on mobile).\n-->\n<div [class.bb-dashboard-backdrop--visible]=\"!(visibility | async)\"\n     (click)=\"toggleSidebarVisibility()\"\n     class=\"bb-dashboard-backdrop\">\n</div>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard'
                        },
                        styles: [".bb-dashboard{height:100vh;display:-ms-flexbox;display:flex;overflow:hidden;position:relative}.bb-dashboard-section{-ms-flex:1;flex:1;height:100vh;display:-ms-flexbox;display:flex;overflow-x:hidden;-ms-flex-direction:column;flex-direction:column}.bb-dashboard-scroll{-ms-flex:1;flex:1;overflow-x:hidden;overflow-y:scroll;-webkit-overflow-scrolling:touch}.bb-dashboard-container{width:100%;margin:0 auto}.bb-dashboard-backdrop{top:0;left:0;right:0;bottom:0;opacity:0;z-index:5;position:absolute;will-change:opacity;pointer-events:none;background-color:rgba(0,0,0,.5);transition:opacity .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-backdrop--visible{opacity:1;cursor:pointer;pointer-events:all}@media only screen and (min-width:768px){.bb-dashboard-backdrop{display:none}}.bb-dashboard-html{height:100%;overflow:hidden}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboard.ctorParameters = function () {
            return [
                { type: i0.Renderer2 }
            ];
        };
        BbDashboard.propDecorators = {
            backgroundColor: [{ type: i0.Input }],
            maxWidth: [{ type: i0.Input }],
            padding: [{ type: i0.Input }]
        };
        return BbDashboard;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboardHeader = /** @class */ (function () {
        function BbDashboardHeader(_parent) {
            this._parent = _parent;
        }
        Object.defineProperty(BbDashboardHeader.prototype, "isSidebarVisible", {
            get: /**
             * @return {?}
             */ function () {
                return this._parent
                    ? this._parent.visibility
                    : rxjs.of(false);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbDashboardHeader.prototype.onToggleSidebarClicked = /**
         * @return {?}
         */
            function () {
                // If the parent exists toggle the sidebar visibility.
                if (!this._parent) {
                    return;
                }
                this._parent.toggleSidebarVisibility();
            };
        BbDashboardHeader.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-dashboard-header',
                        template: "<!--\n    The button that toggles the sidebar.\n-->\n<button (click)=\"onToggleSidebarClicked()\"\n        [class.bb-dashboard-header-button--reversed]=\"isSidebarVisible | async\"\n        class=\"bb-dashboard-header-button\"\n        type=\"button\"\n        tabindex=\"0\"\n        role=\"switch\">\n    <svg xmlns=\"http://www.w3.org/2000/svg\"\n         viewBox=\"0 0 157 109\"\n         width=\"17\"\n         height=\"12\"\n         role=\"img\">\n        <title>\n            Toggle\n        </title>\n        <path fill=\"#fff\"\n              d=\"M82 42V11.2L30 54.5l52 43.3V67h75V42zM9.5 109h-2c-4.1 0-7.5-3.4-7.5-7.5v-94C0 3.4 3.4 0 7.5 0h2C13.6 0 17 3.4 17 7.5v94c0 4.1-3.4 7.5-7.5 7.5z\">\n        </path>\n    </svg>\n</button>\n\n<!--\n    The extra items of the header.\n-->\n<div class=\"bb-dashboard-header-items\">\n    <ng-content></ng-content>\n</div>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard-header'
                        },
                        styles: [".bb-dashboard-header{z-index:1;width:100%;color:#fff;height:50px;display:-ms-flexbox;display:flex;padding:0 8px;min-height:50px;-ms-flex-align:center;align-items:center;background-color:#3f51b5;border-bottom:1px solid #303f9f}.bb-dashboard-header-button{width:68px;height:34px;border-radius:4px;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;-ms-flex-pack:center;justify-content:center;border:1px solid #283593;background-color:transparent}.bb-dashboard-header-button>svg{height:100%;-webkit-transform:none;-ms-transform:none;transform:none;transition:transform .2s cubic-bezier(0,0,.2,1);transition:transform .2s cubic-bezier(0,0,.2,1),-webkit-transform .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-header-button--reversed>svg{-webkit-transform:rotateY(180deg);transform:rotateY(180deg)}.bb-dashboard-header-button:hover{background-color:rgba(0,0,0,.04)}.bb-dashboard-header-button:active{background-color:rgba(0,0,0,.08)}.bb-dashboard-header-items{display:-ms-flexbox;display:flex;margin-left:auto;-ms-flex-align:center;align-items:center}.bb-dashboard-header-items>:not(:first-child){margin-left:8px}@media only screen and (min-width:768px){.bb-dashboard-header-button>svg{-webkit-transform:rotateY(180deg);transform:rotateY(180deg)}.bb-dashboard-header-button--reversed>svg{-webkit-transform:none;-ms-transform:none;transform:none}}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboardHeader.ctorParameters = function () {
            return [
                { type: BbDashboard, decorators: [{ type: i0.Optional }] }
            ];
        };
        return BbDashboardHeader;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboardSidebar = /** @class */ (function () {
        function BbDashboardSidebar(_platform, _parent) {
            var _this = this;
            this._platform = _platform;
            this._parent = _parent;
            // Bindings.
            this.visible = true;
            // State.
            this._state$ = new rxjs.BehaviorSubject([]);
            // Token.
            this._localStorageToken = 'bb-dashboard-sidebar-state';
            this.saveCache = ( /**
             * @param {?} data
             * @return {?}
             */function (data) {
                // Get the local storage.
                /** @type {?} */
                var localStorage = _this.getLocalStorage();
                // Check if the local storage exists.
                if (!localStorage) {
                    return;
                }
                // Set the cache in the local storage.
                try {
                    localStorage.setItem(_this._localStorageToken, JSON.stringify(data));
                }
                catch (error) {
                    console.log('Error setting local storage data.');
                }
            });
        }
        /**
         * @return {?}
         */
        BbDashboardSidebar.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // Retrieve and set the cache.
                this.setCache();
                // Get the visibility observable from the parent
                // if the parent exists.
                /** @type {?} */
                var observable$ = this._parent
                    ? this._parent.visibility
                    : rxjs.of(false);
                // Subscribe to get the state changes.
                this._subscription = observable$
                    .subscribe(( /**
             * @param {?} value
             * @return {?}
             */function (value) { return _this.visible = value; }));
            };
        /**
         * @return {?}
         */
        BbDashboardSidebar.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                // Unsubscribe to prevent memory leaks.
                this._subscription && this._subscription.unsubscribe();
            };
        /**
         * @param {?} id
         * @return {?}
         */
        BbDashboardSidebar.prototype.registerGroup = /**
         * @param {?} id
         * @return {?}
         */
            function (id) {
                // Get the current groups.
                /** @type {?} */
                var current = this._state$.getValue();
                // Check if the id is already inside the groups.
                if (current.findIndex(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) { return item.id === id; })) > -1) {
                    throw new Error('Group id was already defined; can only have distinct id\'s.');
                }
                // Check if the item is in the cache
                // and create a new entry.
                /** @type {?} */
                var cacheItem = this._cache.find(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) { return item.id === id; }));
                /** @type {?} */
                var newEntry = {
                    id: id,
                    state: cacheItem ? cacheItem.state : 'opened'
                };
                // Push the new groups array.
                this._state$.next(__spread(current, [newEntry]));
                // Return the slice of the state that the group needs.
                return this._state$.pipe(operators.map(( /**
                 * @param {?} state
                 * @return {?}
                 */function (state) {
                    return state.find(( /**
                     * @param {?} item
                     * @return {?}
                     */function (item) { return item.id === id; }));
                })), operators.map(( /**
                 * @param {?} group
                 * @return {?}
                 */function (group) { return group.state; })));
            };
        /**
         * @param {?} id
         * @return {?}
         */
        BbDashboardSidebar.prototype.unregisterGroup = /**
         * @param {?} id
         * @return {?}
         */
            function (id) {
                // Get the old groups.
                /** @type {?} */
                var oldValue = this._state$.getValue();
                // Calculate the new groups.
                /** @type {?} */
                var newValue = oldValue.filter(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) { return item.id !== id; }));
                // Push the new groups array.
                this._state$.next(newValue);
            };
        /**
         * @param {?} id
         * @param {?} newState
         * @return {?}
         */
        BbDashboardSidebar.prototype.toggleGroup = /**
         * @param {?} id
         * @param {?} newState
         * @return {?}
         */
            function (id, newState) {
                // Get the old groups.
                /** @type {?} */
                var oldValue = this._state$.getValue();
                // Create the new groups.
                /** @type {?} */
                var newValue = oldValue.map(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) {
                    return item.id !== id
                        ? item
                        : { id: id, state: newState };
                }));
                // Push the new groups array.
                this._state$.next(newValue);
                // Save in the cache.
                this.saveCache(newValue);
            };
        /**
         * @return {?}
         */
        BbDashboardSidebar.prototype.close = /**
         * @return {?}
         */
            function () {
                // Set the sidebar visibility to true, this means
                // that on mobile the sidebar will be closed.
                this._parent.setSidebarVisibility(true);
            };
        /**
         * @private
         * @return {?}
         */
        BbDashboardSidebar.prototype.getLocalStorage = /**
         * @private
         * @return {?}
         */
            function () {
                // Check if the current platform is a browser.
                if (!this._platform.isBrowser) {
                    return null;
                }
                // Check if the window and local storage exist.
                return window && window.localStorage
                    ? localStorage
                    : null;
            };
        /**
         * @private
         * @return {?}
         */
        BbDashboardSidebar.prototype.setCache = /**
         * @private
         * @return {?}
         */
            function () {
                // Get the local storage.
                /** @type {?} */
                var localStorage = this.getLocalStorage();
                // Check if the local storage exists.
                if (!localStorage) {
                    return;
                }
                // Retrieve the raw data from the storage.
                /** @type {?} */
                var rawData = localStorage.getItem(this._localStorageToken);
                // Try to parse the data.
                /** @type {?} */
                var parsedData = null;
                // Only parse the data when it is not null.
                if (rawData !== null) {
                    try {
                        parsedData = JSON.parse(rawData);
                    }
                    catch (error) {
                        console.log('Error parsing local storage data.');
                    }
                }
                // Set the cache to the parsed data.
                this._cache = parsedData || [];
            };
        BbDashboardSidebar.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-dashboard-sidebar',
                        template: "<!--\n    The header of the sidebar.\n-->\n<header class=\"bb-dashboard-sidebar-header\">\n    <ng-content>\n    </ng-content>\n</header>\n\n<!--\n    The scroll area that contains the\n    groups in the navigation.\n-->\n<div class=\"bb-dashboard-sidebar-scroll\">\n    <ng-content select=\"bb-dashboard-sidebar-group\"></ng-content>\n</div>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard-sidebar',
                            'role': 'navigation'
                        },
                        styles: [".bb-dashboard-sidebar{top:0;bottom:0;z-index:10;left:-256px;width:256px;height:100vh;display:block;position:fixed;min-width:256px;will-change:transform;-webkit-transform:translateX(256px);-ms-transform:translateX(256px);transform:translateX(256px);border-right:1px solid rgba(0,0,0,.4);transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1);background:linear-gradient(to bottom,#fff,#f2f2f2) #fff}.bb-dashboard-sidebar.visible{-webkit-transform:none;-ms-transform:none;transform:none}.bb-dashboard-sidebar-header{height:120px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;border-bottom:1px solid #d8d8d8;background-color:rgba(255,255,255,.5)}.bb-dashboard-sidebar-scroll{overflow:auto;height:calc(100vh - 120px)}@media only screen and (min-width:768px){.bb-dashboard-sidebar{left:0;z-index:auto;-webkit-transform:none;-ms-transform:none;transform:none;position:relative;margin-left:-256px;transition:margin-left 250ms cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar.visible{margin-left:0}}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboardSidebar.ctorParameters = function () {
            return [
                { type: BbPlatform },
                { type: BbDashboard, decorators: [{ type: i0.Optional }, { type: i0.Host }] }
            ];
        };
        BbDashboardSidebar.propDecorators = {
            visible: [{ type: i0.HostBinding, args: ['class.visible',] }]
        };
        return BbDashboardSidebar;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboardSidebarGroup = /** @class */ (function () {
        function BbDashboardSidebarGroup(_parent) {
            this._parent = _parent;
            // Inputs.
            this.id = null;
            this.icon = null;
            this.title = null;
            // State.
            this.state = 'opened';
        }
        Object.defineProperty(BbDashboardSidebarGroup.prototype, "isExpanded", {
            // Host bindings.
            get: 
            // Host bindings.
            /**
             * @return {?}
             */
            function () {
                return this.state === 'opened';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbDashboardSidebarGroup.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // Check if the id and title have been supplied.
                if (!this.id || !this.title) {
                    throw new Error('Id and title are required.');
                }
                // Register the group at the parent and
                // retrieve the slice of the state.
                /** @type {?} */
                var observable$ = this._parent
                    ? this._parent.registerGroup(this.id)
                    : rxjs.of('opened');
                // Subscribe to the state.
                this._subscription = observable$
                    .subscribe(( /**
             * @param {?} state
             * @return {?}
             */function (state) { return _this.state = state; }));
            };
        /**
         * @return {?}
         */
        BbDashboardSidebarGroup.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                // Unsubscribe to prevent memory leaks.
                this._subscription && this._subscription.unsubscribe();
                // Unregister the group at the parent.
                this._parent && this._parent.unregisterGroup(this.id);
            };
        /**
         * @return {?}
         */
        BbDashboardSidebarGroup.prototype.onClick = /**
         * @return {?}
         */
            function () {
                // Change the state.
                /** @type {?} */
                var nextState = this.state === 'opened' ? 'closed' : 'opened';
                // Set the state of the sidebar.
                this._parent && this._parent.toggleGroup(this.id, nextState);
            };
        /**
         * @return {?}
         */
        BbDashboardSidebarGroup.prototype.onItemClicked = /**
         * @return {?}
         */
            function () {
                // Close the sidebar on the parent.
                this._parent && this._parent.close();
            };
        BbDashboardSidebarGroup.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-dashboard-sidebar-group',
                        template: "<!--\n    The wrapper that contains the title and icon.\n-->\n<button (click)=\"onClick()\"\n        class=\"bb-dashboard-sidebar-group-title\"\n        type=\"button\"\n        role=\"switch\">\n    <i *ngIf=\"icon\"\n       class=\"material-icons bb-dashboard-sidebar-group-icon\">\n        {{ icon }}\n    </i>\n    <span *ngIf=\"title\"\n          class=\"bb-dashboard-sidebar-group-text\">\n        {{ title }}\n    </span>\n    <span class=\"bb-dashboard-sidebar-group-toggle\">\n        <svg xmlns=\"http://www.w3.org/2000/svg\"\n             viewBox=\"0 0 157 109\"\n             width=\"16\"\n             height=\"16\"\n             role=\"img\">\n            <title>\n                Toggle\n            </title>\n            <path\n                d=\"M82 42V11.2L30 54.5l52 43.3V67h75V42zM9.5 109h-2c-4.1 0-7.5-3.4-7.5-7.5v-94C0 3.4 3.4 0 7.5 0h2C13.6 0 17 3.4 17 7.5v94c0 4.1-3.4 7.5-7.5 7.5z\">\n            </path>\n        </svg>\n    </span>\n</button>\n\n<!--\n    The sidebar items that contain the\n    links to navigate to other pages.\n-->\n<ng-content select=\"[bb-dashboard-sidebar-item]\">\n</ng-content>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard-sidebar-group',
                            'role': 'group'
                        },
                        styles: [".bb-dashboard-sidebar-group{color:#000;display:block;overflow:hidden;border-bottom:1px solid rgba(0,0,0,.1);transition:background-color .2s cubic-bezier(0,0,.2,1),padding-bottom .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-group.expanded{padding-bottom:20px;background-color:rgba(0,0,0,.04)}.bb-dashboard-sidebar-group.expanded .bb-dashboard-sidebar-group-title{color:#000}.bb-dashboard-sidebar-group.expanded .bb-dashboard-sidebar-item{opacity:1;height:32px;line-height:32px;padding:6px 16px 6px 54px}.bb-dashboard-sidebar-group.expanded .bb-dashboard-sidebar-group-toggle>svg{-webkit-transform:rotate(90deg);-ms-transform:rotate(90deg);transform:rotate(90deg)}.bb-dashboard-sidebar-group-title{margin:0;width:100%;border:none;display:-ms-flexbox;display:flex;cursor:pointer;text-align:left;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-ms-flex-align:center;align-items:center;padding:17px 15px;color:rgba(0,0,0,.8);background-color:transparent;transition:color .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-group-title:focus>.bb-dashboard-sidebar-group-toggle,.bb-dashboard-sidebar-group-title:hover>.bb-dashboard-sidebar-group-toggle{opacity:1}.bb-dashboard-sidebar-group-title:active>.bb-dashboard-sidebar-group-toggle{background-color:rgba(0,0,0,.08)}.bb-dashboard-sidebar-group-icon{margin-right:15px;color:rgba(0,0,0,.25)}.bb-dashboard-sidebar-group-text{width:100%;display:block;font-size:14px;max-width:100%;overflow:hidden;font-weight:500;line-height:15px;white-space:nowrap;text-overflow:ellipsis;text-transform:uppercase}.bb-dashboard-sidebar-group-toggle{opacity:0;width:30px;height:30px;display:-ms-flexbox;display:flex;min-width:30px;min-height:30px;border-radius:50%;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;transition:opacity .2s cubic-bezier(0,0,.2,1),background-color .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-group-toggle>svg{width:16px;height:16px;fill:rgba(0,0,0,.25);-webkit-transform:rotate(90deg) rotateY(180deg);transform:rotate(90deg) rotateY(180deg);transition:transform .2s cubic-bezier(0,0,.2,1);transition:transform .2s cubic-bezier(0,0,.2,1),-webkit-transform .2s cubic-bezier(0,0,.2,1)}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboardSidebarGroup.ctorParameters = function () {
            return [
                { type: BbDashboardSidebar, decorators: [{ type: i0.Optional }, { type: i0.Host }] }
            ];
        };
        BbDashboardSidebarGroup.propDecorators = {
            isExpanded: [{ type: i0.HostBinding, args: ['class.expanded',] }],
            id: [{ type: i0.Input }],
            icon: [{ type: i0.Input }],
            title: [{ type: i0.Input }]
        };
        return BbDashboardSidebarGroup;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboardSidebarItem = /** @class */ (function () {
        function BbDashboardSidebarItem(_parent) {
            this._parent = _parent;
            // Inputs.
            this.tabIndex = 0;
        }
        /**
         * @return {?}
         */
        BbDashboardSidebarItem.prototype.onClick = /**
         * @return {?}
         */
            function () {
                // Trigger the parent on item clicked call
                // so that the sidebar can be closed.
                this._parent && this._parent.onItemClicked();
            };
        Object.defineProperty(BbDashboardSidebarItem.prototype, "attributeTabIndex", {
            get: /**
             * @return {?}
             */ function () {
                // Make the items tabindex -1 so it can't
                // be tabbed to when the parent is not expanded.
                if (!this._parent.isExpanded) {
                    return -1;
                }
                // Else return the specified tabindex.
                return this.tabIndex;
            },
            enumerable: true,
            configurable: true
        });
        BbDashboardSidebarItem.decorators = [
            { type: i0.Component, args: [{
                        selector: '[bb-dashboard-sidebar-item]',
                        template: "<!--\n    The content between the tags will\n    be reflected here.\n-->\n<span class=\"bb-dashboard-sidebar-item-content\">\n    <ng-content>\n    </ng-content>\n</span>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard-sidebar-item',
                            '[attr.tabindex]': 'attributeTabIndex'
                        },
                        styles: [".bb-dashboard-sidebar-item{height:0;opacity:0;padding:0;display:-ms-flexbox;display:flex;line-height:0;cursor:pointer;font-size:14px;font-weight:500;margin-right:20px;-ms-flex-align:center;align-items:center;text-decoration:none;will-change:opacity,height;border-top-right-radius:16px;border-bottom-right-radius:16px;color:rgba(0,0,0,.85)!important;transition:height .2s cubic-bezier(0,0,.2,1),opacity .2s cubic-bezier(0,0,.2,1) 50ms,color .2s cubic-bezier(0,0,.2,1),background-color .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-item:focus,.bb-dashboard-sidebar-item:hover{background-color:rgba(0,0,0,.05)}.bb-dashboard-sidebar-item:active{background-color:rgba(0,0,0,.1)}.bb-dashboard-sidebar-item.active,.bb-dashboard-sidebar-item.active:active,.bb-dashboard-sidebar-item.active:focus,.bb-dashboard-sidebar-item.active:hover{color:#000;background-color:rgba(0,0,0,.15)}.bb-dashboard-sidebar-item-content{overflow:hidden;max-width:100%;white-space:nowrap;text-overflow:ellipsis}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboardSidebarItem.ctorParameters = function () {
            return [
                { type: BbDashboardSidebarGroup, decorators: [{ type: i0.Optional }] }
            ];
        };
        BbDashboardSidebarItem.propDecorators = {
            tabIndex: [{ type: i0.Input }],
            onClick: [{ type: i0.HostListener, args: ['click',] }]
        };
        return BbDashboardSidebarItem;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DECLARATIONS_EXPORTS = [
        BbDashboard,
        BbDashboardHeader,
        BbDashboardSidebar,
        BbDashboardSidebarGroup,
        BbDashboardSidebarItem
    ];
    var BbDashboardModule = /** @class */ (function () {
        function BbDashboardModule() {
        }
        BbDashboardModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: __spread(DECLARATIONS_EXPORTS),
                        exports: __spread(DECLARATIONS_EXPORTS)
                    },] }
        ];
        return BbDashboardModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var BbNotificationType = {
        Success: 'success',
        Error: 'error',
        Warning: 'warning',
        Info: 'info',
        Custom: 'custom',
    };
    var BbNotificationsConfig = /** @class */ (function () {
        function BbNotificationsConfig() {
        }
        return BbNotificationsConfig;
    }());
    /** @enum {string} */
    var BbNotificationsPosition = {
        TopRight: 'flex-start|flex-end',
        BottomRight: 'flex-end|flex-end',
        TopLeft: 'flex-start|flex-start',
        BottomLeft: 'flex-end|flex-start',
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var s = '250ms cubic-bezier(0, 0, .2, 1)';
    /** @type {?} */
    var l = '400ms cubic-bezier(0, 0, .2, 1)';
    /** @type {?} */
    var notificationAnimation = animations.trigger('notificationListAnimation', [
        animations.transition('* => *', [
            animations.query(':enter', animations.group([
                // 1. Set the initial state.
                animations.style({ height: 0, opacity: 0, transform: 'translateX({{ to }}%) scale(0.95)' }),
                // 2. Start the animation to show the item.
                animations.stagger(0, [
                    animations.animate(s, animations.style({ height: '*' })),
                    animations.animate(l, animations.style({ opacity: 1, transform: 'translateX(0) scale(0.95)' })),
                    animations.animate(s, animations.style({ transform: 'translateX(0) scale(1)' }))
                ])
            ]), { optional: true }),
            animations.query(':leave', animations.group([
                // 1. Set the initial state.
                animations.style({ height: '*', opacity: 1, transform: 'translateX(0) scale(1)' }),
                // 2. Start the animation to hide the item.
                animations.stagger(0, [
                    animations.animate(s, animations.style({ transform: 'translateX(0) scale(0.95)' })),
                    animations.animate(l, animations.style({ opacity: 0, transform: 'translateX({{ to }}%) scale(0.95)' })),
                    animations.animate(s, animations.style({ height: 0 }))
                ])
            ]), { optional: true })
        ])
    ]);

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbNotificationsList = /** @class */ (function () {
        function BbNotificationsList() {
            // Track by function.
            this.trackByFn = ( /**
             * @param {?} _
             * @param {?} item
             * @return {?}
             */function (_, item) { return item.id; });
        }
        Object.defineProperty(BbNotificationsList.prototype, "horizontalPosition", {
            get: /**
             * @return {?}
             */ function () {
                return this.location.horizontal;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbNotificationsList.prototype, "verticalPosition", {
            get: /**
             * @return {?}
             */ function () {
                return this.location.vertical;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbNotificationsList.prototype, "animation", {
            get: /**
             * @return {?}
             */ function () {
                /** @type {?} */
                var to = this.horizontalPosition === 'flex-start'
                    ? -50
                    : 50;
                return { to: to };
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbNotificationsList.prototype, "location", {
            get: /**
             * @private
             * @return {?}
             */ function () {
                var _a = __read((this.position || '').split('|'), 2), y = _a[0], x = _a[1];
                return { vertical: y || null, horizontal: x || null };
            },
            enumerable: true,
            configurable: true
        });
        BbNotificationsList.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-notifications-list',
                        template: "<!--\n    The notifications list.\n\n    The list provides the animation effect for the\n    incoming notifications.\n-->\n<div *ngIf=\"notifications$ | async as notifications\"\n     [@notificationListAnimation]=\"{value: notifications?.length, params: animation}\"\n     class=\"notifications-list-wrapper\">\n    <!--\n        The loop for the notifications.\n\n        All notifications will be displayed here. They\n        are wrapped within a wrapper which separates them.\n    -->\n    <div *ngFor=\"let notification of notifications; trackBy: trackByFn\"\n         class=\"notifications-item-wrapper\">\n        <bb-notifications-item [notification]=\"notification\"\n                               [dismissButtonText]=\"dismissText\">\n        </bb-notifications-item>\n    </div>\n</div>\n",
                        animations: [notificationAnimation],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-notifications-list',
                            'role': 'list'
                        },
                        styles: [".bb-notifications-list{top:0;left:0;right:0;bottom:0;z-index:500;padding:10px;display:-ms-flexbox;display:flex;position:fixed;pointer-events:none}.notifications-list-wrapper{width:100%;display:block;max-width:400px;position:relative}.notifications-item-wrapper{padding:0;margin:0 0 10px;pointer-events:all}"]
                    }] }
        ];
        BbNotificationsList.propDecorators = {
            horizontalPosition: [{ type: i0.HostBinding, args: ['style.justify-content',] }],
            verticalPosition: [{ type: i0.HostBinding, args: ['style.align-items',] }]
        };
        return BbNotificationsList;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbNotificationsItem = /** @class */ (function () {
        function BbNotificationsItem(_zone, _platform, _changeDetection) {
            var _this = this;
            this._zone = _zone;
            this._platform = _platform;
            this._changeDetection = _changeDetection;
            // Data.
            this._progress = 0;
            this._count = 0;
            // Data.
            this._radius = 19;
            this._circumference = this._radius * 2 * Math.PI;
            this.callActionAndDestroy = ( /**
             * @param {?} notification
             * @param {?} action
             * @return {?}
             */function (notification, action) {
                // Perform the callback (if it exists).
                action && action.callback && action.callback();
                // Call the destroy method (if it exists).
                notification && notification.destroy && notification.destroy();
            });
            this.instance = ( /**
             * @return {?}
             */function () {
                // Calculate the difference.
                _this._difference = (new Date().getTime() - _this._startTime) - (_this._count * _this._speed);
                // Add up the count.
                if (_this._count++ === _this._steps) {
                    _this.notification.destroy();
                }
                // Add the steps to the progress.
                _this._progress += 100 / _this._steps;
                // Set a new timer.
                _this._timer = _this.setTimeout(_this.instance, _this._speed - _this._difference);
                // Run a new change detection cycle.
                _this._zone.run(( /**
                 * @return {?}
                 */function () { return _this._changeDetection.detectChanges(); }));
            });
            this.setTimeout = ( /**
             * @param {?} method
             * @param {?} timeout
             * @return {?}
             */function (method, timeout) {
                // Check if the window and method exist.
                if (!window || !window.setTimeout) {
                    return null;
                }
                return window.setTimeout(method, timeout);
            });
        }
        Object.defineProperty(BbNotificationsItem.prototype, "getClass", {
            get: /**
             * @return {?}
             */ function () {
                return "bb-notifications-item " + this.notification.type;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbNotificationsItem.prototype, "progressStrokeArray", {
            get: /**
             * @return {?}
             */ function () {
                /** @type {?} */
                var value = Math.floor(this._circumference);
                return value + ", " + value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbNotificationsItem.prototype, "progressStrokeOffset", {
            get: /**
             * @return {?}
             */ function () {
                return Math.floor(this._circumference - this._progress / 100 * this._circumference);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbNotificationsItem.prototype, "isContentString", {
            get: /**
             * @return {?}
             */ function () {
                return typeof this.notification.content === 'string';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbNotificationsItem.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                // Check if the notification timeout is not 0 and the platform is a browser.
                if (this.notification.timeout <= 0 || !this._platform.isBrowser) {
                    this.notification.dismiss = true;
                    return;
                }
                // Start the timeout.
                this.startTimeout();
            };
        /**
         * @return {?}
         */
        BbNotificationsItem.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                // Clear the timeout if it was set.
                this._timer && window && window.clearTimeout && window.clearTimeout(this._timer);
            };
        /**
         * @private
         * @return {?}
         */
        BbNotificationsItem.prototype.startTimeout = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                // Calculate the steps of the timeout.
                this._steps = this.notification.timeout / 10;
                // Calculate the speed of the timeout.
                this._speed = this.notification.timeout / this._steps;
                // Get the start time.
                this._startTime = new Date().getTime();
                // Set a new timer outside of Angular.
                this._zone.runOutsideAngular(( /**
                 * @return {?}
                 */function () { return _this._timer = _this.setTimeout(_this.instance, _this._speed); }));
            };
        BbNotificationsItem.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-notifications-item',
                        template: "<div class=\"notification-content-wrapper\">\n    <!--\n        The icon for the notification.\n\n        The icon is reflected by the type of the\n        notification. Same goes for the color and\n        background-color.\n    -->\n    <div [style.color]=\"notification?.color\"\n         [style.background-color]=\"notification?.backgroundColor\"\n         class=\"notification-icon-wrapper\">\n        <svg xmlns=\"http://www.w3.org/2000/svg\"\n             viewBox=\"0 0 16 19.5\"\n             class=\"notification-icon\">\n            <path\n                d=\"M8 19.5c1.1 0 2-.9 2-2H6c0 1.1.9 2 2 2zM14 13.5v-5c0-3.1-1.6-5.6-4.5-6.3v-.7C9.5.7 8.8 0 8 0S6.5.7 6.5 1.5v.7C3.6 2.9 2 5.4 2 8.5v5l-2 2v1h16v-1l-2-2z\">\n            </path>\n        </svg>\n\n        <!--\n            The circular progress for the notification.\n\n            The progress is only visible when a timeout is\n            set. The progress adapts to the time remaining\n            for the notification.\n        -->\n        <svg *ngIf=\"notification?.timeout > 0\"\n             class=\"notification-progress-ring\"\n             viewBox=\"0 0 40 40\"\n             role=\"progressbar\">\n            <circle #progress\n                    [attr.stroke-dasharray]=\"progressStrokeArray\"\n                    [attr.stroke-dashoffset]=\"progressStrokeOffset\"\n                    [style.stroke]=\"notification?.color\"\n                    class=\"notification-progress-circle\"\n                    stroke-width=\"2\"\n                    fill=\"transparent\"\n                    r=\"19\"\n                    cx=\"20\"\n                    cy=\"20\">\n            </circle>\n        </svg>\n    </div>\n\n    <!--\n        The content for the notification.\n\n        This displays a string or a template based\n        on the given parameter by the user.\n    -->\n    <div class=\"notification-content\">\n        <ng-container *ngIf=\"isContentString; else templateContent\">\n            {{ notification?.content }}\n        </ng-container>\n    </div>\n</div>\n\n<!--\n    The actions of the notification.\n\n    All actions are displayed here and are\n    based on the actions array the user provided.\n-->\n<div *ngIf=\"notification?.actions?.length > 0 || notification?.dismiss\"\n     class=\"notification-actions\">\n    <button *ngFor=\"let action of notification?.actions\"\n            (click)=\"callActionAndDestroy(notification, action)\"\n            type=\"button\"\n            [class.destructive]=\"action?.type === 'cancel'\"\n            class=\"notification-actions-button\">\n        <span class=\"notification-actions-button-highlight\">{{ action?.title }}</span>\n    </button>\n    <button *ngIf=\"notification?.dismiss\"\n            (click)=\"notification?.destroy()\"\n            class=\"notification-actions-button destructive\"\n            type=\"button\">\n        <span class=\"notification-actions-button-highlight\">{{ notification?.dismissText || dismissButtonText }}</span>\n    </button>\n</div>\n\n<!--\n    The outlet for the notification content template ref.\n-->\n<ng-template #templateContent>\n    <ng-container *ngTemplateOutlet=\"notification?.content\"></ng-container>\n</ng-template>\n",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'role': 'alert'
                        },
                        styles: [".bb-notifications-item{display:-ms-flexbox;display:flex;border-radius:4px;-ms-flex-direction:column;flex-direction:column;background-color:#fff;border:1px solid #d6dbe0}.bb-notifications-item.success .notification-icon-wrapper{color:#2dc05d;background-color:#ebfaf0}.bb-notifications-item.success .notification-progress-circle{stroke:#36d068}.bb-notifications-item.error .notification-icon-wrapper{color:#f43e3e;background-color:#feeeee}.bb-notifications-item.error .notification-progress-circle{stroke:#f55656}.bb-notifications-item.warning .notification-icon-wrapper{color:#f1ae00;background-color:#fff8e7}.bb-notifications-item.warning .notification-progress-circle{stroke:#ffbc0b}.bb-notifications-item.info .notification-icon-wrapper{color:#099bf6;background-color:#e9f6fe}.bb-notifications-item.info .notification-progress-circle{stroke:#22a5f7}.bb-notifications-item.custom .notification-icon-wrapper{color:#657385;background-color:#f3f5f6}.bb-notifications-item.custom .notification-progress-circle{stroke:#657385}.notification-content-wrapper{padding:20px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center}.notification-icon-wrapper{width:40px;height:40px;display:-ms-flexbox;display:flex;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;position:relative;border-radius:50%;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;color:#657385;background-color:#f3f5f6}.notification-icon{width:100%;height:100%;padding:10px;fill:currentColor}.notification-content{-ms-flex:1;flex:1;font-size:14px;line-height:1.5;font-weight:500;margin-left:20px;color:rgba(0,0,0,.85)}.notification-content i{font-style:italic}.notification-actions-button,.notification-content{font-family:inherit}.notification-actions{display:-ms-flexbox;display:flex;margin:0 20px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;border-top:1px solid #f3f5f6}.notification-actions-button{-ms-flex:1;flex:1;border:none;color:#22a5f7;cursor:pointer;font-size:14px;font-weight:500;padding:12px 2px;text-align:center;background-color:transparent}.notification-actions-button:focus>.notification-actions-button-highlight,.notification-actions-button:hover>.notification-actions-button-highlight{background-color:rgba(34,165,247,.1)}.notification-actions-button:active>.notification-actions-button-highlight{background-color:rgba(34,165,247,.2)}.notification-actions-button.destructive{color:#f55656}.notification-actions-button.destructive:focus>.notification-actions-button-highlight,.notification-actions-button.destructive:hover>.notification-actions-button-highlight{background-color:rgba(245,86,86,.1)}.notification-actions-button.destructive:active>.notification-actions-button-highlight{background-color:rgba(245,86,86,.2)}.notification-actions-button-highlight{padding:4px 12px;border-radius:12px;display:-ms-inline-flexbox;display:inline-flex;transition:background-color 150ms cubic-bezier(0,0,.2,1)}.notification-progress-ring{top:0;left:0;right:0;bottom:0;width:100%;height:100%;position:absolute}.notification-progress-circle{-webkit-transform:rotate(-90deg);-ms-transform:rotate(-90deg);transform:rotate(-90deg);-webkit-transform-origin:50% 50%;-ms-transform-origin:50% 50%;transform-origin:50% 50%;stroke:#657385}"]
                    }] }
        ];
        /** @nocollapse */
        BbNotificationsItem.ctorParameters = function () {
            return [
                { type: i0.NgZone },
                { type: BbPlatform },
                { type: i0.ChangeDetectorRef }
            ];
        };
        BbNotificationsItem.propDecorators = {
            notification: [{ type: i0.Input }],
            dismissButtonText: [{ type: i0.Input }],
            progressElementRef: [{ type: i0.ViewChild, args: ['progress',] }],
            getClass: [{ type: i0.HostBinding, args: ['class',] }]
        };
        return BbNotificationsItem;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbNotificationsModule = /** @class */ (function () {
        function BbNotificationsModule(parentModule) {
            if (parentModule) {
                throw new Error('BbNotificationsModule is already loaded. Import it in the AppModule only');
            }
        }
        /**
         * @param {?=} config
         * @return {?}
         */
        BbNotificationsModule.forRoot = /**
         * @param {?=} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: BbNotificationsModule,
                    providers: [
                        { provide: BbNotificationsConfig, useValue: config }
                    ]
                };
            };
        BbNotificationsModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [BbNotificationsList, BbNotificationsItem],
                        entryComponents: [BbNotificationsList]
                    },] }
        ];
        /** @nocollapse */
        BbNotificationsModule.ctorParameters = function () {
            return [
                { type: BbNotificationsModule, decorators: [{ type: i0.Optional }, { type: i0.SkipSelf }] }
            ];
        };
        return BbNotificationsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbNotifications = /** @class */ (function () {
        function BbNotifications(_injector, _platform, _applicationRef, _config, _componentFactoryResolver) {
            this._injector = _injector;
            this._platform = _platform;
            this._applicationRef = _applicationRef;
            this._config = _config;
            this._componentFactoryResolver = _componentFactoryResolver;
            // The data containing the notifications.
            this._notifications$ = new rxjs.BehaviorSubject([]);
            this.getProperty = ( /**
             * @param {?} property
             * @param {?} defaultValue
             * @return {?}
             */function (property, defaultValue) {
                return typeof property === 'undefined'
                    ? defaultValue
                    : property;
            });
            // Get the config.
            /** @type {?} */
            var config = this._config || {};
            // Set the config.
            this._defaultMode = this.getProperty(config.mode, 'prepend');
            this._defaultTimeout = this.getProperty(config.timeout, 8000);
            this._defaultDismiss = this.getProperty(config.dismiss, true);
            this._defaultDismissText = this.getProperty(config.dismissText, 'Dismiss');
            this._defaultPosition = this.getProperty(config.position, BbNotificationsPosition.TopRight);
            // Create the element that holds all notifications.
            this.createElement();
        }
        /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
        BbNotifications.prototype.success = /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
            function (content, actions, timeout) {
                if (actions === void 0) {
                    actions = [];
                }
                if (timeout === void 0) {
                    timeout = this._defaultTimeout;
                }
                return this.create({ content: content, timeout: timeout, actions: actions, type: BbNotificationType.Success });
            };
        /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
        BbNotifications.prototype.error = /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
            function (content, actions, timeout) {
                if (actions === void 0) {
                    actions = [];
                }
                if (timeout === void 0) {
                    timeout = this._defaultTimeout;
                }
                return this.create({ content: content, timeout: timeout, actions: actions, type: BbNotificationType.Error });
            };
        /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
        BbNotifications.prototype.warn = /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
            function (content, actions, timeout) {
                if (actions === void 0) {
                    actions = [];
                }
                if (timeout === void 0) {
                    timeout = this._defaultTimeout;
                }
                return this.create({ content: content, timeout: timeout, actions: actions, type: BbNotificationType.Warning });
            };
        /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
        BbNotifications.prototype.info = /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
            function (content, actions, timeout) {
                if (actions === void 0) {
                    actions = [];
                }
                if (timeout === void 0) {
                    timeout = this._defaultTimeout;
                }
                return this.create({ content: content, timeout: timeout, actions: actions, type: BbNotificationType.Info });
            };
        /**
         * @param {?} notification
         * @return {?}
         */
        BbNotifications.prototype.create = /**
         * @param {?} notification
         * @return {?}
         */
            function (notification) {
                var _this = this;
                // Compose a new notification item.
                /** @type {?} */
                var item = this.compose(notification);
                // Add the destroy function to the notification.
                item.destroy = ( /**
                 * @return {?}
                 */function () { return _this.pull(item); });
                // Add the notification to the list
                // and return the item.
                return this.push(item);
            };
        /**
         * @private
         * @param {?} notification
         * @return {?}
         */
        BbNotifications.prototype.push = /**
         * @private
         * @param {?} notification
         * @return {?}
         */
            function (notification) {
                // Get the current list.
                /** @type {?} */
                var oldList = this._notifications$.getValue();
                // Check which mode is activated.
                /** @type {?} */
                var newList = __spread(oldList);
                switch (this._defaultMode) {
                    case 'append':
                        newList = __spread(oldList, [notification]);
                        break;
                    case 'prepend':
                    default:
                        newList = __spread([notification], oldList);
                }
                // Push the new notifications.
                this._notifications$.next(newList);
                // Return the notification for further use.
                return notification;
            };
        /**
         * @private
         * @param {?} notification
         * @return {?}
         */
        BbNotifications.prototype.pull = /**
         * @private
         * @param {?} notification
         * @return {?}
         */
            function (notification) {
                // Get the current list.
                /** @type {?} */
                var newList = this._notifications$
                    .getValue()
                    .filter(( /**
             * @param {?} item
             * @return {?}
             */function (item) { return item.id !== notification.id; }));
                // Push a new list.
                this._notifications$.next(newList);
            };
        /**
         * @private
         * @param {?} notification
         * @return {?}
         */
        BbNotifications.prototype.compose = /**
         * @private
         * @param {?} notification
         * @return {?}
         */
            function (notification) {
                // Attach a random id to the notification.
                notification.id = Math.random().toString(36).substr(2, 10);
                // Set all properties.
                notification.type = this.getProperty(notification.type, BbNotificationType.Custom);
                notification.content = this.getProperty(notification.content, null);
                notification.timeout = this.getProperty(notification.timeout, this._defaultTimeout);
                notification.dismiss = this.getProperty(notification.dismiss, this._defaultDismiss);
                notification.dismissText = this.getProperty(notification.dismissText, this._defaultDismissText);
                // Return the composed notification.
                return notification;
            };
        /**
         * @private
         * @return {?}
         */
        BbNotifications.prototype.createElement = /**
         * @private
         * @return {?}
         */
            function () {
                // Create the notification list and
                // get a reference to the component.
                this._ref = this._componentFactoryResolver
                    .resolveComponentFactory(BbNotificationsList)
                    .create(this._injector);
                // Save a reference to the notifications on
                // the component.
                this._ref.instance.notifications$ = this._notifications$.pipe(operators.share());
                this._ref.instance.dismissText = this._defaultDismissText;
                this._ref.instance.position = this._defaultPosition;
                // Attach the component's view to the application
                // so that the change detection will run properly.
                this._applicationRef.attachView(this._ref.hostView);
                // If the platform is not a browser return.
                if (!this._platform.isBrowser) {
                    return;
                }
                try {
                    // Append the element to the DOM.
                    document.body.appendChild(this._ref.location.nativeElement);
                }
                catch (_a) {
                    // Don't do anything, because it must've failed.
                }
            };
        BbNotifications.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: BbNotificationsModule
                    },] }
        ];
        /** @nocollapse */
        BbNotifications.ctorParameters = function () {
            return [
                { type: i0.Injector },
                { type: BbPlatform },
                { type: i0.ApplicationRef },
                { type: BbNotificationsConfig, decorators: [{ type: i0.Optional }] },
                { type: i0.ComponentFactoryResolver }
            ];
        };
        /** @nocollapse */ BbNotifications.ngInjectableDef = i0.defineInjectable({ factory: function BbNotifications_Factory() { return new BbNotifications(i0.inject(i0.INJECTOR), i0.inject(BbPlatform), i0.inject(i0.ApplicationRef), i0.inject(BbNotificationsConfig, 8), i0.inject(i0.ComponentFactoryResolver)); }, token: BbNotifications, providedIn: BbNotificationsModule });
        return BbNotifications;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbLocalizeConfig = /** @class */ (function () {
        function BbLocalizeConfig() {
            this.production = false;
            this.dictionary = [];
        }
        return BbLocalizeConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbLocalize = /** @class */ (function () {
        function BbLocalize(_storage, _language, _interpolator, _config) {
            var _this = this;
            this._storage = _storage;
            this._language = _language;
            this._interpolator = _interpolator;
            this._config = _config;
            this._currentDictionary = null;
            this._storageToken = 'bb-language-dictionary-name';
            this.log = ( /**
             * @param {?} message
             * @return {?}
             */function (message) {
                console && console.warn && console.warn(message);
            });
            this.reload = ( /**
             * @return {?}
             */function () {
                window && window.location && window.location.reload && window.location.reload();
            });
            // Check if at least one language was submitted to the service.
            if (this._config.dictionary.length < 1) {
                throw new Error('Localize: one or more languages should be supplied.');
            }
            // Save the dictionary.
            this._dictionary = this._config.dictionary;
            // Get the storage language.
            /** @type {?} */
            var storageToken = this._storage.get(this._storageToken);
            /** @type {?} */
            var storageLanguage = this._dictionary
                .find(( /**
         * @param {?} item
         * @return {?}
         */function (item) { return item.name === storageToken; }));
            // Retrieve the supported language.
            /** @type {?} */
            var supportedLanguage = this._language.all.map(( /**
             * @param {?} __0
             * @return {?}
             */function (_a) {
                var code = _a.code, region = _a.region;
                /** @type {?} */
                var languageCode = [code, region].filter(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) { return !!data; })).join('-');
                return _this._dictionary.find(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) { return item.languages.includes(languageCode); }));
            })).filter(( /**
             * @param {?} item
             * @return {?}
             */function (item) { return !!item; })).find(( /**
             * @param {?} _
             * @param {?} index
             * @return {?}
             */function (_, index) { return index === 0; }));
            // Make sure the user always has a language by picking
            // the first language if the users browser does not
            // support any language.
            this._currentDictionary = storageLanguage || supportedLanguage || this._dictionary[0];
        }
        /**
         * @return {?}
         */
        BbLocalize.prototype.getLocale = /**
         * @return {?}
         */
            function () {
                // Check if the locale is not there, then just return the
                // default locale.
                if (!this._currentDictionary || !this._currentDictionary.locale) {
                    return 'en-US';
                }
                // Return the locale that is set in the dictionary.
                return this._currentDictionary.locale;
            };
        /**
         * @param {?} language
         * @return {?}
         */
        BbLocalize.prototype.setLanguage = /**
         * @param {?} language
         * @return {?}
         */
            function (language) {
                // Try to fetch the dictionary.
                /** @type {?} */
                var dictionary = this._dictionary.find(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) { return item.languages.includes(language); }));
                // Check if the dictionary was found.
                if (!dictionary) {
                    return this.log("Localize: The language with name: \"" + language + "\" was not found.");
                }
                // Save the language in the storage.
                this._storage.set(this._storageToken, dictionary.name);
                // We need to reload the application for the translations.
                this.reload();
            };
        /**
         * @return {?}
         */
        BbLocalize.prototype.unsetLanguage = /**
         * @return {?}
         */
            function () {
                // Remove the language in the local storage.
                this._storage.remove(this._storageToken);
                // We need to reload the application for the translations.
                this.reload();
            };
        /**
         * @param {?} token
         * @param {?=} data
         * @return {?}
         */
        BbLocalize.prototype.translate = /**
         * @param {?} token
         * @param {?=} data
         * @return {?}
         */
            function (token, data) {
                if (data === void 0) {
                    data = {};
                }
                // Retrieve the translation from the dictionary.
                /** @type {?} */
                var translation = this.searchForTranslation(token);
                // Warn the user if the token was not
                // found in the dictionary.
                if (!translation && !this._config.production) {
                    this.log("Localize: The token with name: \"" + token + "\" was not found.");
                    return token;
                }
                // If the user did not define any extra data
                // just return the translation.
                if (Object.keys(data).length < 1) {
                    return translation;
                }
                // The user has added extra data that needs to be
                // interpolated.
                return this._interpolator.interpolate(translation, data);
            };
        /**
         * @private
         * @param {?} token
         * @return {?}
         */
        BbLocalize.prototype.searchForTranslation = /**
         * @private
         * @param {?} token
         * @return {?}
         */
            function (token) {
                // Grab the dictionary data.
                /** @type {?} */
                var data = this._currentDictionary.data;
                // Check if the token is present in the dictionary.
                if (data[token]) {
                    return data[token];
                }
                // Else search the dictionary for the translation
                // by splitting on the dot.
                /** @type {?} */
                var translation = token.split('.').filter(( /**
                 * @param {?} value
                 * @return {?}
                 */function (value) { return !!value; })).reduce(( /**
                 * @param {?} dictionary
                 * @param {?} value
                 * @return {?}
                 */function (dictionary, value) {
                    if (dictionary === undefined || typeof dictionary === 'string') {
                        return undefined;
                    }
                    return dictionary[value];
                }), data);
                // Check if the translation is a string
                // if this is true it can be returned.
                if (typeof translation === 'string') {
                    return translation;
                }
                // This means the translation was not
                // correct.
                return null;
            };
        BbLocalize.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        BbLocalize.ctorParameters = function () {
            return [
                { type: BbStorage },
                { type: BbLanguage },
                { type: BbInterpolator },
                { type: BbLocalizeConfig, decorators: [{ type: i0.Optional }] }
            ];
        };
        return BbLocalize;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbLocalizePipe = /** @class */ (function () {
        function BbLocalizePipe(_localize) {
            this._localize = _localize;
        }
        /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
        BbLocalizePipe.prototype.transform = /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
            function (value, args) {
                if (args === void 0) {
                    args = {};
                }
                // Validate that the data exists.
                if (!this._localize || !value) {
                    return value;
                }
                // Check if the args were formatted properly.
                if (typeof args !== 'object') {
                    throw new Error('Localize: The pipe arguments were not formatted properly.');
                }
                // Try to translate the value.
                return this._localize.translate(value, args);
            };
        BbLocalizePipe.decorators = [
            { type: i0.Pipe, args: [{
                        name: 'bbLocalize'
                    },] }
        ];
        /** @nocollapse */
        BbLocalizePipe.ctorParameters = function () {
            return [
                { type: BbLocalize, decorators: [{ type: i0.Optional }] }
            ];
        };
        return BbLocalizePipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbLocalizeModule = /** @class */ (function () {
        function BbLocalizeModule(parentModule) {
            if (parentModule) {
                throw new Error('BbLocalizeModule is already loaded. Import it in the AppModule only');
            }
        }
        /**
         * @param {?} config
         * @return {?}
         */
        BbLocalizeModule.forRoot = /**
         * @param {?} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: BbLocalizeModule,
                    providers: [
                        { provide: BbLocalizeConfig, useValue: config },
                        { provide: i0.LOCALE_ID, deps: [BbLocalize], useFactory: getLocale }
                    ]
                };
            };
        BbLocalizeModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [BbLocalize],
                        declarations: [BbLocalizePipe],
                        exports: [BbLocalizePipe]
                    },] }
        ];
        /** @nocollapse */
        BbLocalizeModule.ctorParameters = function () {
            return [
                { type: BbLocalizeConfig, decorators: [{ type: i0.Optional }, { type: i0.SkipSelf }] }
            ];
        };
        return BbLocalizeModule;
    }());
    /**
     * @param {?} localize
     * @return {?}
     */
    function getLocale(localize) {
        // This is done in a exported function to prevent the
        // "lambda is not supported" error.
        return localize.getLocale();
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.BbPlatform = BbPlatform;
    exports.BbLanguage = BbLanguage;
    exports.BbStorage = BbStorage;
    exports.BbImage = BbImage;
    exports.BbInterpolator = BbInterpolator;
    exports.BbDashboard = BbDashboard;
    exports.BbDashboardHeader = BbDashboardHeader;
    exports.BbDashboardSidebar = BbDashboardSidebar;
    exports.BbDashboardSidebarGroup = BbDashboardSidebarGroup;
    exports.BbDashboardSidebarItem = BbDashboardSidebarItem;
    exports.BbDashboardModule = BbDashboardModule;
    exports.BbNotificationType = BbNotificationType;
    exports.BbNotificationsConfig = BbNotificationsConfig;
    exports.BbNotificationsPosition = BbNotificationsPosition;
    exports.BbNotifications = BbNotifications;
    exports.BbNotificationsModule = BbNotificationsModule;
    exports.BbLocalizeConfig = BbLocalizeConfig;
    exports.BbLocalize = BbLocalize;
    exports.BbLocalizePipe = BbLocalizePipe;
    exports.getLocale = getLocale;
    exports.BbLocalizeModule = BbLocalizeModule;
    exports.ɵc = BbNotificationsItem;
    exports.ɵa = BbNotificationsList;
    exports.ɵb = notificationAnimation;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=bravobit-bb-foundation.umd.js.map